# Python3 Programm zur
# Erzeugung von 109 Stahlbauprofilen als DWG-Datei
# mittels der Skriptfunktion von AutoCAD

# CC-by-SA 2012 Dipl.-Ing. Martin Vogel, Hochschule Bochum


P = open("Stahlbau-Profiltabelle.csv","r") # zu lesende Profiltabelle
S = open("Stahlbauprofile.scr","w")        # zu schreibende AutoCAD-Befehle 

Überschrift = P.readline() # Überschrift "weglesen", wird nicht benötigt

print("filedia 0",file=S)  # Dateidialoge in AutoCAD ausschalten
print("ofang kei",file=S)  # Objektfang in AutoCAD ausschalten
print("intelligentupdate 0",file=S) # Keine Verzögerung im Bildaufbau

for Zeile in P:
    Reihe,Nennhöhe,h,b,s,t,r,h1,A,Iy,Wy,iy,Iz,Wz,iz,Sy,sy,g = Zeile.split(",")
    Profil=Reihe+"-"+Nennhöhe
    h  = float(h)    # Umwandlung Zeichenkette in Gleitkommazahl
    h1 = float(h1)
    b  = float(b)
    s  = float(s)
    t  = float(t)
    r  = float(r)    # Die anderen Profilwerte werden hier nicht benötigt
    f1 = (b-s)/2-r   # Gerades Stück des Flansches (nicht tabelliert)
    print(Profil)    # Kontrollausgabe

    print("_erase alle ",file=S) # Zeichnung leeren
    if Reihe=="I":
        # Profil aufwendig konstruieren. Das ließe sich vermeiden, indem
        # man die Tangentenschnittpunkte des schrägen Flansches mit
        # den beiden Ausrundungen ausrechnete.
        r1=s
        r2=r
        x0,y0=-b/2,-h/2
        xr1,yr1=-1.5*s,-h1/2
        # Zuerst einmal heranzoomen, damit AutoCAD überhaupt
        # die Konstruktionspunkte findet :-(
        print("ZOOM F %f,%f %f,%f"%(-0.6*b,-0.6*h,0.6*b,0.6*h),file=S)

        # linke untere Steghälfte
        print("LINIE %f,0 @0,%f "%(-s/2,-h1/2),file=S)
        # linke untere Flanschhälfte;
        # links ein 1mm senkrecht stehendes Stück für die
        # spätere Ausrundung r2 ansetzen
        print("LINIE 0,%f @%f,0 @0,1 "%(-h/2,-b/2),file=S)
        # Ausrundung Flansch-Steg (r1)
        print("KREIS %f,%f %f"%(xr1,yr1,r1),file=S)
        # schräger Flansch, Fixpunkt bei b/4, t
        print("LINIE %f,%f TAN %f,%f "%(-b/4,y0+t,xr1,yr1-r1),file=S)
        # Kreis auf Ausrundung r1 zuschneiden
        print("STUTZEN %f,0 %f,%f \n%f,%f "%(-s/2,-b/4,y0+t,xr1-r1,yr1),file=S)
        # Ausrundung Flanschrand (r2)
        # Das zweite "Abrunden" ist nötig, weil AutoCAD 2010 manchmal(!)
        # aus dem Befehl herausplumpst (argh!)
        print("ABRUNDEN R %f ABRUNDEN %f,%f %f,%f"%(r2,x0,y0+1,-b/4,y0+t),file=S)
        # alles nach rechts klappen
        print("SPIEGELN ALLE \n0,0 0,1 N",file=S)
        # alles nach open klappen
        print("SPIEGELN ALLE \n0,0 1,0 N",file=S)
        # vereinigen
        print("PEDIT O ALLE \nJ V 1 ",file=S)
    else:
        # Profil als geschlossene Polylinie zeichnen:
        print("""plinie
%f,%f @0,%f @%f,0
k @%f,%f
l @0,%f
k @%f,%f
l @%f,0 @0,%f @%f,0 @0,%f @%f,0
k @%f,%f
l @0,%f
k @%f,%f
l @%f,0 @0,%f
s"""%(-b/2,-h/2,t,f1,r,r,h1,-r,r,-f1,t,b,-t,-f1,-r,-r,-h1,r,-r,f1,-t),file=S)

    # Aktuelle Zeichnung als Block schreiben
    print("-wblock",Profil,"*",file=S)

print("filedia 1",file=S) # Dateidialoge in AutoCAD wieder einschalten

print("\nIn AutoCAD kann \"Stahlbauprofile.scr\" jetzt in einer leeren(!)")
print("Zeichnung mit SCRIPT gestartet werden.")
print("\nDie Profildateien werden ins Standard-Dokumentenverzeichnis geschrieben.")
P.close()    
S.close()    
